module OPEBigStep where
open import Utils
open import Syntax
open import OPE
open import OPELemmas
open import BigStepSemantics

mutual
  eval⇓map : forall {B Γ Δ σ}(f : OPE B Γ)
             {t : Tm Δ σ}{vs : Env Γ Δ}{v : Val Γ σ} ->
             eval t & vs ⇓ v -> eval t & emap f vs ⇓ vmap f v
  eval⇓map f rvar            = rvar 
  eval⇓map f (rsubs p p')    = rsubs (evalˢ⇓map f p) (eval⇓map f p') 
  eval⇓map f rlam            = rlam 
  eval⇓map f (rapp p p' p'') = 
    rapp (eval⇓map f p) (eval⇓map f p') ($$⇓map f p'') 
  eval⇓map f rzero           = rzero
  eval⇓map f (rsuc p)        = rsuc (eval⇓map f p)
  eval⇓map f (rprim p p' p'' p''') = 
    rprim (eval⇓map f p) (eval⇓map f p') (eval⇓map f p'') (prim⇓map f p''')

  prim⇓map : forall {B Γ σ}(f : OPE B Γ)
             {z : Val Γ σ}{s : Val Γ (N → σ → σ)}{v : Val Γ N}{w : Val Γ σ} ->
             prim z & s & v ⇓ w -> 
             prim vmap f z & vmap f s & vmap f v ⇓ vmap f w
  prim⇓map f rprn            = rprn 
  prim⇓map f rprz            = rprz 
  prim⇓map f (rprs p p' p'') = 
    rprs ($$⇓map f p) (prim⇓map f p') ($$⇓map f p'') 

  $$⇓map : forall {Γ Δ σ τ}(f : OPE Γ Δ)
           {v : Val Δ (σ → τ)}{a : Val Δ σ}{v' : Val Δ τ} ->
           v $$ a ⇓ v' -> vmap f v $$ vmap f a ⇓ vmap f v'
  $$⇓map f (r$lam p) = r$lam (eval⇓map f p) 
  $$⇓map f r$ne      = r$ne 

  evalˢ⇓map : forall {A B Γ Δ}(f : OPE A B)
              {ts : Sub Γ Δ}{vs : Env B Γ}{ws : Env B Δ} ->
              evalˢ ts & vs ⇓ ws -> evalˢ ts & emap f vs ⇓ emap f ws
  evalˢ⇓map f rˢpop         = rˢpop 
  evalˢ⇓map f (rˢcons p p') = rˢcons (evalˢ⇓map f p) (eval⇓map f p') 
  evalˢ⇓map f rˢid          = rˢid 
  evalˢ⇓map f (rˢcomp p p') = rˢcomp (evalˢ⇓map f p) (evalˢ⇓map f p')

mutual
  quote⇓map : forall {Γ Δ σ}(f : OPE Γ Δ) ->
              {v : Val Δ σ}{n : Nf Δ σ} ->
              quote v ⇓ n -> quote vmap f v ⇓ nfmap f n
  quote⇓map f (qbase p)   = qbase (quoteⁿ⇓map f p) 
  quote⇓map {σ = σ → τ} f (qarr {f = v} p p') with $$⇓map (keep _ f) p
  ... | p'' with vmap (keep σ f) (vmap (skip σ oid) v) | quotelemma σ f v
  ... | ._ | refl⁼ = qarr p'' (quote⇓map (keep _ f) p') 
  quote⇓map {σ = N} f qNz     = qNz
  quote⇓map {σ = N} f (qNs p) = qNs (quote⇓map f p)
  quote⇓map {σ = N} f (qNn p) = qNn (quoteⁿ⇓map f p)

  quoteⁿ⇓map : forall {Γ Δ σ}(f : OPE Γ Δ) ->
              {n : NeV Δ σ}{n' : NeN Δ σ} ->
              quoteⁿ n ⇓ n' -> quoteⁿ nevmap f n ⇓ nenmap f n'
  quoteⁿ⇓map f qⁿvar        = qⁿvar 
  quoteⁿ⇓map f (qⁿapp p p') = qⁿapp (quoteⁿ⇓map f p) (quote⇓map f p') 
  quoteⁿ⇓map f (qⁿprim p p' p'') =
    qⁿprim (quote⇓map f p) (quote⇓map f p') (quoteⁿ⇓map f p'')